@echo off
set badParam=false


REM Script to set TPP Application Pool timeouts.
REM %1 sets the number of minutes for the Idle timeout for each TPP AppPool
REM %2 sets the number of hours for the Recycle time (Regular Time Interval) for each TPP AppPool

if [%1] == [] set badParam=true
if [%2] == [] set badParam=true

if "%badParam%" == "true" (
	call :Usage %0
	goto :EOF
) 

REM Need to make sure that both parameters are two digits

call :strlen %1% strlength

if %strlength% NEQ 2 (
	call :Usage %0
	goto :EOF
) 

call :strlen %2% strlength

if %strlength% NEQ 2 (
	call :Usage %0
	goto :EOF
) 


echo.
echo Setting Idle Timeout to %1%
echo Setting Regular Time Interval to %2%



:SetAppPools
REM Aperture AppPool
echo %systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='Aperture'].processModel.idleTimeout:0.00:%1%:00"
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='Aperture'].processModel.idleTimeout:0.00:%1%:00"
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='Aperture'].recycling.periodicRestart.time:0.%2%:00:00"

REM VEDClient AppPool
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDClient'].processModel.idleTimeout:0.00:%1%:00"
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDClient'].recycling.periodicRestart.time:0.%2%:00:00"

REM VEDScep AppPool
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDScep'].processModel.idleTimeout:0.00:%1%:00"
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDScep'].recycling.periodicRestart.time:0.%2%:00:00"

REM VEDWebSDK AppPool
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDWebSDK'].processModel.idleTimeout:0.00:%1%:00"
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDWebSDK'].recycling.periodicRestart.time:0.%2%:00:00"

REM VEDAdmin AppPool
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDAdmin'].processModel.idleTimeout:0.00:%1%:00"
%systemroot%\system32\inetsrv\appcmd set config /section:applicationPools "/[name='VEDAdmin'].recycling.periodicRestart.time:0.%2%:00:00"
goto :EOF

:strLen
	(ECHO %1%)> tempfile.txt
	FOR %%? IN (tempfile.txt) DO ( SET /A strlength=%%~z? - 2 )
goto :eof

:Usage
	echo.
	echo Usage:
	echo [IdleTimeMinutes] [RegularTimeIntevalHours]
	echo.
	echo IdleTimeMinutes - The number of minutes for the Idle Timeout that will be set for all AppPools
	echo RegularTimeIntevalHours - The number of hours for the Regular Time Interal that will be set for all AppPools
	echo.
	echo NOTE: Both parameters MUST be two digits (e.g., 00, 01, 25).
	echo.
goto :EOF
